<template>
  <div class="container">
    <h2 class="text-center">Add/Edit your product here</h2>

    <form @submit.prevent="onSubmit">

      <div class="form-group">
        <label for="title">Product Name</label>
        <input class="form-control"
               id="title"
               type="text"
               placeholder="Enter title"
               v-model="title"
               @blur="$v.title.$touch()"
               :class="{'is-invalid': $v.title.$error}"/>
        <span class="invalid-feedback">
                        <span v-if="!$v.title.required">
                            Please enter the product name.
                        </span>
                        <span v-if="!$v.title.minLen">
                            Product name must be greater than 5 characters.
                        </span>
                </span>
      </div>

      <div class="form-group">
        <label for="content">Description</label>
        <textarea class="form-control"
                  id="content"
                  rows="3"
                  @blur="$v.content.$touch()"
                  :class="{'is-invalid': $v.content.$error}"
                  v-model="content"></textarea>
        <span class="invalid-feedback">
                        <span v-if="!$v.content.required">
                            Please enter the description.
                        </span>
                </span>
      </div>

      <div class="input-group mb-3">
        <div class="input-group-prepend">
          <span class="input-group-text">Rs.</span>
        </div>
        <input type="number"
               class="form-control"
               aria-label="Amount (to the nearest rupees)" placeholder="Enter Price"
               @blur="$v.price.$touch()"
               :class="{'is-invalid': $v.price.$error}"
               v-model="price"/>
        <div class="input-group-append">
          <span class="input-group-text">.00</span>
        </div>
        <span class="invalid-feedback">
                        <span v-if="!$v.price.required">
                            Please enter the price.
                        </span>
                         <span v-if="!$v.price.maxVal">
                            Only products costing less than Rs 5,00,000 can be added.
                        </span>

                </span>
      </div>

      <div class="productImage" v-if="editMode">
        <img :src="`http://localhost:5000/uploads/${product.photo}`"
             class="rounded mx-auto d-block img-fluid" alt="...">
      </div>

      <div class="form-group">
        <label for="image">Upload Image</label>
        <input id="image"
               type="file"
               class="form-control-file"
               :class="{'is-invalid': $v.image.$error}"
               @change="onFileSelect($event)"/>
        <span class="invalid-feedback">
                        <span v-if="!$v.image.required">
                            Please upload image.
                        </span>
                </span>
      </div>

      <button class="btn btn-primary"
              type="submit"
              style="width:80px">
        Save
      </button>
    </form>
  </div>
</template>

<script>
import {required, minLength, maxValue} from 'vuelidate/lib/validators';
import {mergeMap} from 'rxjs/operators';
import ProductService from "../../services/product.service";

export default {
  data() {
    return {
      title: '',
      content: '',
      price: null,
      image: '',
      product: null,
      editMode: false,
      productId: '',
      noFile: true
    }
  },
  created() {
    this.product = this.$route.meta.product;
    if (this.product) {
      this.editMode = true;
      this.productId = this.$route.params.id;
      this.title = this.product.productName;
      this.content = this.product.description;
      this.price = this.product.price;
      this.image = this.product.photo;
    }
  },
  validations: {
    title: {
      required,
      minLen: minLength(5)
    },
    content: {
      required
    },
    price: {
      required,
      maxVal: maxValue(500000)
    },
    image: {
      required
    }
  },
  methods: {
    onFileSelect(event) {
      this.$v.image.$touch();
      const files = event.target.files;
      if (!files.length) {
        return;
      }
      if (files.length > 0) {
        this.noFile = false;
        this.image = files.item(0);
      }
    },
    addImage(productId) {
      const mediaData = new FormData();
      mediaData.append('file', this.image);
      return ProductService.addMedia(mediaData, productId);
    },
    onSubmit() {
      this.$v.$touch();
      const formData = new FormData();
      formData.append('productName', this.title);
      formData.append('description', this.content);
      formData.append('price', this.price);
      if (!this.$v.$invalid) {
        if (!this.editMode) {
          ProductService.addProduct(formData)
              .pipe(
                  mergeMap(product => this.addImage(product.data.id)))
              .subscribe(() => this.$router.replace('/shop'));
        }
        if(this.editMode) {
          if(!this.noFile) {
            ProductService.updateProduct(formData, this.productId)
                .pipe(
                    mergeMap(() => this.addImage(this.productId)))
                .subscribe(() => this.$router.replace('/shop'));
          }
          if(this.noFile) {
            ProductService.updateProduct(formData, this.productId)
                .subscribe(() => this.$router.replace('/shop'));
          }
        }
      }
    }
  }
}
</script>
